@use crate::cat_page::CatPage;
@use crate::format_downloads;
@use crate::iter::*;
@use crate::limit_description_len;
@use crate::templates::base_html;
@use crate::templates::labels_html;
@use crate::templates::search_icon_html;
@use crate::Urler;
@use rich_crate::Origin;
@use kitchen_sink::SortOrder;

@(p: &CatPage<'_>, url: &Urler)

@:base_html(&p.page(), {
    <header id="category" class="cat-@p.cat.slug">
        <div class="inner-col">
            @:search_icon_html()
            <div class="breadcrumbs" typeof="BreadcrumbList">
            <h1>
              <span property="itemListElement" typeof="ListItem">
                <a property="item" typeof="WebPage" href="/"><span property="name">Lib</span>.rs</a>
                <meta property="position" content="1">
              </span>
            </h1>
            ›
            <span property="itemListElement" typeof="ListItem">
              <a href="/#home-categories" property="item" typeof="WebPage"><span property="name">Categories</span></a>
              <meta property="position" content="2">
            </span>
            ›
            <span class="categories has-keywords">
            @for (i, subcat) in p.parent_categories().iter().enumerate() {
                <span property="itemListElement" typeof="ListItem">
                  <a href="@url.category(subcat, p.sort_order)" title="@subcat.short_description" property="item" typeof="WebPage"><span property="name">@subcat.name</span></a>
                  <meta property="position" content="@(i+3)">
                </span>
                ›
            }
            </span>
            <span class="keywords">
              <span>
                @for key in p.keywords.iter().take(3) {
                  <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
                }
              </span>
              @for key in p.keywords.iter().skip(3).take(3) {
                <a href="@url.keyword(key)" class=keyword><span>#</span>@key</a>
              }
            </span>

            <h2>@p.cat.standalone_name()</h2>
            <p class=desc>@p.description()</p>
            </div>

            <nav><ul>
              @if p.main_page_nav {
                <li><a href="/">Categories</a></li>
                <li><a href="/new">New and trending</a></li>
                <li><a href="/stats">Stats</a></li>
              }
              <li class=active>@if p.crates.len() != p.count {
                    @if p.sort_order == SortOrder::Recency { latest } @p.crates.len() of @p.count crates @if p.sort_order == SortOrder::Popularity { by downloads }
                } else {
                    @p.count @if p.sort_order == SortOrder::Recency { latest } crates @if p.sort_order == SortOrder::Popularity { by downloads }
                }
              </li>
              @if p.main_page_nav {
                <li><a href="/dash">Maintainer Dashboard</a></li>
              }
              @if !p.main_page_nav && p.cat.slug != "cryptography::cryptocurrencies" {
                <li class="sort-by"><span>Sort:
                @if p.sort_order == SortOrder::Quality { <b>Best</b> } else { <a rel="canonical" href="@url.category(p.cat, SortOrder::Quality)">Best</a> }
                @if p.sort_order == SortOrder::Popularity { <b>Popular</b> } else { <a rel="nofollow" href="@url.category(p.cat, SortOrder::Popularity)">Popular</a> }
                @if p.sort_order == SortOrder::Recency { <b>New</b> } else { <a rel="nofollow" href="@url.category(p.cat, SortOrder::Recency)">New</a> }
                </span></li>
              }
            </ul></nav>
        </div>
    </header>

    <main class="cat-@p.cat.slug">
        @if p.has_subcategories_and_siblings() {
          <nav id="category-subcategories" role="navigation">
            <div class="inner-col">
              <ul class="crates-list">
                @for subcat in p.subcategories_and_siblings() {
                    <li><a href="@url.category(subcat, p.sort_order)">
                      <div class=h>
                        <h4>@subcat.name</h4>
                        <p class=desc>@subcat.description</p>
                      </div>
                    </a></li>
                }
              </ul>
            </div>
          </nav>
          <hr>
        }

        <div id="category-crates">
          <div class="inner-col">
            <ul class="crates-list">
                @for (c, downloads) in &p.crates {
                <li>
                    <a href="@url.krate(c)">
                        <div class=h>
                            <h4>@if let Some((repo, _)) = c.origin().simple_repo() {@repo.owner/}@c.short_name()</h4>
                            @if let Some(desc) = c.description() {
                              <p class=desc>@p.render_maybe_markdown_str(&limit_description_len(desc, 180, 220, c.short_name()))</p>
                            }
                        </div>
                        <div class=meta>
                            <span class="version @p.version_class(c)"><span>@if let Origin::GitHub{..} = c.origin() {GitHub } else {v}</span>@c.version()</span>
                            @if *downloads >= 100 {
                              <span class=downloads title="@downloads recent downloads">@if let Some((num,unit)) = Some(format_downloads(*downloads)) {@num<b>@unit</b>}</span>
                            }
                            @:labels_html(c, (false, false), false, "")
                            @for k in c.keywords() {
                                <span class=k><span>#</span>@k</span>
                            }
                        </div>
                    </a>
                </li>
                }
            </ul>
            <p class=next-page><a href="/next-page">Next page?</a></p>
          </div>
        </div>
    </main>
    <footer>
      @if let Some(related) = Some(p.related_categories()) {
      @if !related.is_empty() {
        <div class=seealso>
        <nav class="inner-col" aria-label="See also">
          See also:
            @for (last, cat) in related.iter().identify_last() {
            @for (last, subcat) in cat.iter().identify_last() {
              <a href="@url.category(subcat, p.sort_order)" title="@subcat.short_description">@subcat.name</a>
              @if !last {›}
            }
            @if !last {|}
          }
        </nav>
        </div>
      }
      }
      <div class="inner-col"><a href="@(url.category(p.cat, p.sort_order)).atom" rel="alternate" type="application/atom+xml">Atom feed</a>. @p.footnote</div>
      </footer>
})
